Package: pollinationDashIo
Title: Pollination input/output components for Dash to use with pollination apps
Version: 1.0.0
Description: Pollination input/output components for Dash to use with pollination apps
Depends: R (>= 3.0.2)
Imports: 
Suggests: 
License: Apache-2.0 + file LICENSE
URL: https://github.com/https://github.com/pollination/pollination-dash-io
BugReports: https://github.com/https://github.com/pollination/pollination-dash-io/issues
Encoding: UTF-8
LazyData: true
KeepSource: true

# pollination-dash-io

Pollination input/output components for Dash to use with pollination apps

## Install

```shell
pip install pollination_dash_io
```

## Development
### Getting Started

1. Create a new python environment:
   ```shell
   python -m venv venv
   . venv/bin/activate
   ```
   _Note: venv\Scripts\activate for windows_

2. Install python dependencies:
   ```shell
   pip install -r requirements.txt
   ```
3. Install npm packages:
   1. Optional: use [nvm](https://github.com/nvm-sh/nvm) to manage node version:
      ```shell
      nvm install
      nvm use
      ```
   2. Install:
      ```shell
      npm install
      ```
4. Build:
   ```shell
   npm run build
   ```

### Component Code

### Publish

If publish on npm:
```shell
npm build
npm publish
```

### Justfile

Alternatively, use the provided [just](https://github.com/casey/just) commands:

1. Create a Python environment from previous step 1 and install:
   ```shell
   just install
   ```
2. Build
   ```shell
   just build
   ```
3. Publish
   ```shell
   just publish
   ```
4. See all commands with `just -l`

# AUTO GENERATED FILE - DO NOT EDIT

export ''_readlocalfile

"""
    ''_readlocalfile(;kwargs...)

A ReadLocalFile component.
Read a local file

State
- file (string): Base64 string representation of the content
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
- `filePath` (String; required): Full path or relative path where the file is
"""
function ''_readlocalfile(; kwargs...)
        available_props = Symbol[:id, :filePath]
        wild_props = Symbol[]
        return Component("''_readlocalfile", "ReadLocalFile", "pollination_dash_io", available_props, wild_props; kwargs...)
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_runcommand

"""
    ''_runcommand(;kwargs...)

A RunCommand component.
Use this component to run command using CAD
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
- `command` (optional): Command to run

It can be a macro or command name of the host software
___________________________________
Available complex command for Rhino

View from sun
E.g.
```
{
    name: 'ViewFromSun'
    param: {
        target: {'x': 0, 'y': 0, 'z': 0, 'type': 'Point3D'},
        direction: {'x': -0.062823, 'y': 1.904328, 'z': -0.42219, 'type': 'Vector3D'},
        displayName: 'Shaded'
    }
}
```

Add directional light
E.g.
```
{
    name: 'SetRhinoDirectLight'
    param: {
        vectors: [{'x': -0.062823, 'y': 1.904328, 'z': -0.42219, 'type': 'Vector3D'}]
    }
}
```. command has the following type: String | lists containing elements 'name', 'param'.
Those elements have the following types:
  - `name` (String; required)
  - `param` (String; required)
- `hideButton` (Bool; optional): Show/hide button
- `prefix` (String; optional): Prefix of the label
- `trigger` (Bool | Real | String | Dict | Array; optional): External trigger
"""
function ''_runcommand(; kwargs...)
        available_props = Symbol[:id, :command, :hideButton, :prefix, :trigger]
        wild_props = Symbol[]
        return Component("''_runcommand", "RunCommand", "pollination_dash_io", available_props, wild_props; kwargs...)
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_selectstudy

"""
    ''_selectstudy(;kwargs...)

A SelectStudy component.
Select a pollination study

State
- study (dictionary): Study information
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
- `accessToken` (String; optional): JWT token
- `apiKey` (String; optional): API key from Pollination Cloud
- `basePath` (String; optional): Base path of the API.
- `projectName` (String; optional): Name of the project
- `projectOwner` (String; optional): Owner of the project
- `studyId` (String; optional): Default ID of the study
- `value` (optional): Default cloud job. value has the following type: lists containing elements 'author', 'id', 'owner', 'recipe', 'resources_duration', 'spec', 'status'.
Those elements have the following types:
  - `author` (optional): author
@,type,{AccountPublic}
@,memberof,CloudJob. author has the following type: lists containing elements 'account_type', 'description', 'display_name', 'id', 'name', 'picture_url'.
Those elements have the following types:
  - `account_type` (String; required)
  - `description` (String; optional)
  - `display_name` (String; optional)
  - `id` (String; required)
  - `name` (String; required)
  - `picture_url` (String; optional): https://robohash.org/ladybugbot
@,type,{string}
@,memberof,AccountPublic
  - `id` (String; required): The unique ID for this run
@,type,{string}
@,memberof,CloudJob
  - `owner` (optional): owner
@,type,{AccountPublic}
@,memberof,CloudJob. owner has the following type: lists containing elements 'account_type', 'description', 'display_name', 'id', 'name', 'picture_url'.
Those elements have the following types:
  - `account_type` (String; required)
  - `description` (String; optional)
  - `display_name` (String; optional)
  - `id` (String; required)
  - `name` (String; required)
  - `picture_url` (String; optional): https://robohash.org/ladybugbot
@,type,{string}
@,memberof,AccountPublic
  - `recipe` (optional): The recipe used to generate this
@,type,{RecipeInterface}
@,memberof,CloudJob. recipe has the following type: lists containing elements 'annotations', 'api_version', 'inputs', 'metadata', 'outputs', 'source', 'type'.
Those elements have the following types:
  - `annotations` (Dict with Strings as keys and values of type String; optional): An optional dictionary to add annotations to inputs. These annotations will be used by the client side libraries.
@,type,{{ [key: string]: string; }}
@,memberof,RecipeInterface
  - `api_version` (String; optional)
  - `inputs` (Array of Bool | Real | String | Dict | Arrays; optional): A list of recipe inputs.
@,type,{Array<DAGGenericInput | DAGStringInput | DAGIntegerInput | DAGNumberInput | DAGBooleanInput | DAGFolderInput | DAGFileInput | DAGPathInput | DAGArrayInput | DAGJSONObjectInput>}
@,memberof,RecipeInterface
  - `metadata` (required): Recipe metadata information.
@,type,{MetaData}
@,memberof,RecipeInterface. metadata has the following type: lists containing elements 'annotations', 'app_version', 'deprecated', 'description', 'home', 'icon', 'keywords', 'license', 'maintainers', 'name', 'sources', 'tag', 'type'.
Those elements have the following types:
  - `annotations` (Dict with Strings as keys and values of type String; optional): An optional dictionary to add annotations to inputs. These annotations will be used by the client side libraries.
@,type,{{ [key: string]: string; }}
@,memberof,MetaData
  - `app_version` (String; optional): The version of the application code underlying the manifest
@,type,{string}
@,memberof,MetaData
  - `deprecated` (Bool; optional): Whether this package is deprecated
@,type,{boolean}
@,memberof,MetaData
  - `description` (String; optional): A description of what this package does
@,type,{string}
@,memberof,MetaData
  - `home` (String; optional): The URL of this package\'s home page
@,type,{string}
@,memberof,MetaData
  - `icon` (String; optional): A URL to an SVG or PNG image to be used as an icon
@,type,{string}
@,memberof,MetaData
  - `keywords` (Array of Strings; optional): A list of keywords to search the package by
@,type,{Array<string>}
@,memberof,MetaData
  - `license` (optional): The license information.
@,type,{License}
@,memberof,MetaData. license has the following type: lists containing elements 'annotations', 'name', 'type', 'url'.
Those elements have the following types:
  - `annotations` (Dict with Strings as keys and values of type String; optional): An optional dictionary to add annotations to inputs. These annotations will be used by the client side libraries.
@,type,{{ [key: string]: string; }}
@,memberof,License
  - `name` (String; required): The license name used for the package.
@,type,{string}
@,memberof,License
  - `type` (String; optional)
  - `url` (String; optional): A URL to the license used for the package.
@,type,{string}
@,memberof,License
  - `maintainers` (optional): A list of maintainers for the package
@,type,{Array<Maintainer>}
@,memberof,MetaData. maintainers has the following type: Array of lists containing elements 'annotations', 'email', 'name', 'type'.
Those elements have the following types:
  - `annotations` (Dict with Strings as keys and values of type String; optional): An optional dictionary to add annotations to inputs. These annotations will be used by the client side libraries.
@,type,{{ [key: string]: string; }}
@,memberof,Maintainer
  - `email` (String; optional): The email address of the author/maintainer person or organization.
@,type,{string}
@,memberof,Maintainer
  - `name` (String; required): The name of the author/maintainer person or organization.
@,type,{string}
@,memberof,Maintainer
  - `type` (String; optional)s
  - `name` (String; required): Package name. Make it descriptive and helpful ;)
@,type,{string}
@,memberof,MetaData
  - `sources` (Array of Strings; optional): A list of URLs to source code for this project
@,type,{Array<string>}
@,memberof,MetaData
  - `tag` (String; required): The tag of the package
@,type,{string}
@,memberof,MetaData
  - `type` (String; optional)
  - `outputs` (Array of Bool | Real | String | Dict | Arrays; optional): A list of recipe outputs.
@,type,{Array<DAGGenericOutput | DAGStringOutput | DAGIntegerOutput | DAGNumberOutput | DAGBooleanOutput | DAGFolderOutput | DAGFileOutput | DAGPathOutput | DAGArrayOutput | DAGJSONObjectOutput>}
@,memberof,RecipeInterface
  - `source` (String; optional): A URL to the source this recipe from a registry.
@,type,{string}
@,memberof,RecipeInterface
  - `type` (String; optional)
  - `resources_duration` (optional): CPU and Memory usage aggregated for all runs in this job
@,type,{ResourcesDuration}
@,memberof,CloudJob. resources_duration has the following type: lists containing elements 'cpu', 'memory'.
Those elements have the following types:
  - `cpu` (Real; optional)
  - `memory` (Real; optional)
  - `spec` (required): The job specification
@,type,{Job}
@,memberof,CloudJob. spec has the following type: lists containing elements 'annotations', 'api_version', 'arguments', 'description', 'labels', 'name', 'source', 'type'.
Those elements have the following types:
  - `annotations` (Dict with Strings as keys and values of type String; optional): An optional dictionary to add annotations to inputs. These annotations will be used by the client side libraries.
@,type,{{ [key: string]: string; }}
@,memberof,Job
  - `api_version` (String; optional)
  - `arguments` (Array of Array of Bool | Real | String | Dict | Arrayss; optional): Input arguments for this job.
@,type,{Array<Array<JobArgument | JobPathArgument>>}
@,memberof,Job
  - `description` (String; optional): Run description.
@,type,{string}
@,memberof,Job
  - `labels` (Dict with Strings as keys and values of type String; optional): Optional user data as a dictionary. User data is for user reference only and will not be used in the execution of the job.
@,type,{{ [key: string]: string; }}
@,memberof,Job
  - `name` (String; optional): An optional name for this job. This name will be used a the display name for the run.
@,type,{string}
@,memberof,Job
  - `source` (String; required): The source url for downloading the recipe.
@,type,{string}
@,memberof,Job
  - `type` (String; optional)
  - `status` (optional): The status of the job
@,type,{JobStatus}
@,memberof,CloudJob. status has the following type: lists containing elements 'annotations', 'api_version', 'finished_at', 'id', 'message', 'runs_cancelled', 'runs_completed', 'runs_failed', 'runs_pending', 'runs_running', 'source', 'started_at', 'status', 'type'.
Those elements have the following types:
  - `annotations` (Dict with Strings as keys and values of type String; optional): An optional dictionary to add annotations to inputs. These annotations will be used by the client side libraries.
@,type,{{ [key: string]: string; }}
@,memberof,JobStatus
  - `api_version` (String; optional)
  - `finished_at` (String; optional): The time at which the task was completed
@,type,{string}
@,memberof,JobStatus
  - `id` (String; required): The ID of the individual job.
@,type,{string}
@,memberof,JobStatus
  - `message` (String; optional): Any message produced by the job. Usually error/debugging hints.
@,type,{string}
@,memberof,JobStatus
  - `runs_cancelled` (Real; optional): The count of runs that have been cancelled
@,type,{number}
@,memberof,JobStatus
  - `runs_completed` (Real; optional): The count of runs that have completed
@,type,{number}
@,memberof,JobStatus
  - `runs_failed` (Real; optional): The count of runs that have failed
@,type,{number}
@,memberof,JobStatus
  - `runs_pending` (Real; optional): The count of runs that are pending
@,type,{number}
@,memberof,JobStatus
  - `runs_running` (Real; optional): The count of runs that are running
@,type,{number}
@,memberof,JobStatus
  - `source` (String; optional): Source url for the status object. It can be a recipe or a function.
@,type,{string}
@,memberof,JobStatus
  - `started_at` (String; required): The time at which the job was started
@,type,{string}
@,memberof,JobStatus
  - `status` (a value equal to: 'Created', 'Pre-Processing', 'Running', 'Failed', 'Cancelled', 'Completed', 'Unknown'; optional): The status of this job.
@,type,{JobStatusEnum}
@,memberof,JobStatus
  - `type` (String; optional)
"""
function ''_selectstudy(; kwargs...)
        available_props = Symbol[:id, :accessToken, :apiKey, :basePath, :projectName, :projectOwner, :studyId, :value]
        wild_props = Symbol[]
        return Component("''_selectstudy", "SelectStudy", "pollination_dash_io", available_props, wild_props; kwargs...)
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_authuser

"""
    ''_authuser(;kwargs...)

An AuthUser component.
Get authenticated user

State
- client (dictionary): Client information
- authUser (dictionary): Authenticated user information
- token (string): Access Token
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
- `accessToken` (String; optional): JWT token
- `apiKey` (String; optional): API key from Pollination Cloud
- `basePath` (String; optional): Base path of the API.
"""
function ''_authuser(; kwargs...)
        available_props = Symbol[:id, :accessToken, :apiKey, :basePath]
        wild_props = Symbol[]
        return Component("''_authuser", "AuthUser", "pollination_dash_io", available_props, wild_props; kwargs...)
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_managesettings

"""
    ''_managesettings(;kwargs...)

A ManageSettings component.
Use this component to get the host name
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
- `settings` (optional): Settings to apply. settings has the following type: lists containing elements 'location', 'units', 'layers', 'tolerance', 'angle_tolerance'.
Those elements have the following types:
  - `location` (required): . location has the following type: lists containing elements 'city', 'latitude', 'longitude', 'time_zone', 'elevation'.
Those elements have the following types:
  - `city` (String; required)
  - `latitude` (Real; required)
  - `longitude` (Real; required)
  - `time_zone` (Real; required)
  - `elevation` (Real; required)
  - `units` (a value equal to: 'Meters', 'Millimeters', 'Feet', 'Inches', 'Centimeters'; required)
  - `layers` (Array of Strings; required)
  - `tolerance` (Real; required)
  - `angle_tolerance` (Real; required)
"""
function ''_managesettings(; kwargs...)
        available_props = Symbol[:id, :settings]
        wild_props = Symbol[]
        return Component("''_managesettings", "ManageSettings", "pollination_dash_io", available_props, wild_props; kwargs...)
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_sendgeometry

"""
    ''_sendgeometry(;kwargs...)

A SendGeometry component.
Send geometry to a CAD Platform
geometry must be a single Display Geometry or Ladybug Geometry or a list of them
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
- `defaultAction` (a value equal to: 'add', 'delete', 'preview', 'clear', 'subscribe-preview'; optional)
- `defaultKey` (String; optional)
- `geometry` (Array of Strings; optional)
- `geometryOptions` (optional): . geometryOptions has the following type: lists containing elements 'units'.
Those elements have the following types:
  - `units` (a value equal to: 'Meters', 'Millimeters', 'Feet', 'Inches', 'Centimeters'; optional)
- `optionsConfig` (optional): . optionsConfig has the following type: lists containing elements 'add', 'delete', 'preview', 'clear', 'subscribe-preview'.
Those elements have the following types:
  - `add` (Bool; required)
  - `delete` (Bool; required)
  - `preview` (Bool; required)
  - `clear` (Bool; required)
  - `subscribe-preview` (Bool; required)
"""
function ''_sendgeometry(; kwargs...)
        available_props = Symbol[:id, :defaultAction, :defaultKey, :geometry, :geometryOptions, :optionsConfig]
        wild_props = Symbol[]
        return Component("''_sendgeometry", "SendGeometry", "pollination_dash_io", available_props, wild_props; kwargs...)
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_sendhbjson

"""
    ''_sendhbjson(;kwargs...)

A SendHbjson component.
Send a HBJSON model to a CAD Platform
hbjson must be a valid HBJSON model
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
- `defaultAction` (a value equal to: 'add', 'delete', 'preview', 'clear', 'subscribe-preview', 'replace'; optional)
- `defaultKey` (String; optional)
- `hbjson` (Dict; optional)
- `optionsConfig` (optional): . optionsConfig has the following type: lists containing elements 'add', 'delete', 'preview', 'clear', 'subscribe-preview', 'replace'.
Those elements have the following types:
  - `add` (Bool; required)
  - `delete` (Bool; required)
  - `preview` (Bool; required)
  - `clear` (Bool; required)
  - `subscribe-preview` (Bool; required)
  - `replace` (Bool; required)
"""
function ''_sendhbjson(; kwargs...)
        available_props = Symbol[:id, :defaultAction, :defaultKey, :hbjson, :optionsConfig]
        wild_props = Symbol[]
        return Component("''_sendhbjson", "SendHbjson", "pollination_dash_io", available_props, wild_props; kwargs...)
end

module PollinationDashIo
using Dash

const resources_path = realpath(joinpath( @__DIR__, "..", "deps"))
const version = "1.0.0"

include("jl/''_authuser.jl")
include("jl/''_createstudy.jl")
include("jl/''_epwmap.jl")
include("jl/''_getgeometry.jl")
include("jl/''_gethbjson.jl")
include("jl/''_gethost.jl")
include("jl/''_managesettings.jl")
include("jl/''_readlocalfile.jl")
include("jl/''_recipeinputsform.jl")
include("jl/''_runcommand.jl")
include("jl/''_selectaccount.jl")
include("jl/''_selectcloudartifact.jl")
include("jl/''_selectproject.jl")
include("jl/''_selectrecipe.jl")
include("jl/''_selectrun.jl")
include("jl/''_selectstudy.jl")
include("jl/''_sendgeometry.jl")
include("jl/''_sendhbjson.jl")
include("jl/''_sendresults.jl")
include("jl/''_studyprogress.jl")

function __init__()
    DashBase.register_package(
        DashBase.ResourcePkg(
            "pollination_dash_io",
            resources_path,
            version = version,
            [
                DashBase.Resource(
    relative_package_path = "pollination_dash_io.js",
    external_url = nothing,
    dynamic = nothing,
    async = nothing,
    type = :js
),
DashBase.Resource(
    relative_package_path = "pollination_dash_io.js.map",
    external_url = nothing,
    dynamic = true,
    async = nothing,
    type = :js
)
            ]
        )

    )
end
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_createstudy

"""
    ''_createstudy(;kwargs...)

A CreateStudy component.
Create a pollination study

State
- study (dictionary): Study information
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
- `accessToken` (String; optional): JWT token
- `apiKey` (String; optional): API key from Pollination Cloud
- `basePath` (String; optional): Base path of the API.
"""
function ''_createstudy(; kwargs...)
        available_props = Symbol[:id, :accessToken, :apiKey, :basePath]
        wild_props = Symbol[]
        return Component("''_createstudy", "CreateStudy", "pollination_dash_io", available_props, wild_props; kwargs...)
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_buttontest

"""
    ''_buttontest(;kwargs...)

A ButtonTest component.
Component description
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
"""
function ''_buttontest(; kwargs...)
        available_props = Symbol[:id]
        wild_props = Symbol[]
        return Component("''_buttontest", "ButtonTest", "pollination_dash_io", available_props, wild_props; kwargs...)
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_getgeometry

"""
    ''_getgeometry(;kwargs...)

A GetGeometry component.
Use this component to get geometry from CAD
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
- `buttonLabel` (String; optional)
- `defaultKey` (String; required)
- `fullWidth` (Bool; optional)
- `geometryFilter` (optional): . geometryFilter has the following type: lists containing elements 'type', 'layer'.
Those elements have the following types:
  - `type` (Array of Strings; optional)
  - `layer` (Array of Strings; optional)
- `meshOptions` (optional): . meshOptions has the following type: lists containing elements 'gridSize', 'union'.
Those elements have the following types:
  - `gridSize` (Real; optional)
  - `union` (Bool; optional)
- `optionsConfig` (optional): . optionsConfig has the following type: lists containing elements 'selection', 'subscribe', 'preview'.
Those elements have the following types:
  - `selection` (required): . selection has the following type: lists containing elements 'show', 'selected'.
Those elements have the following types:
  - `show` (Bool; optional)
  - `selected` (Bool; optional)
  - `subscribe` (required): . subscribe has the following type: lists containing elements 'show', 'selected'.
Those elements have the following types:
  - `show` (Bool; optional)
  - `selected` (Bool; optional)
  - `preview` (required): . preview has the following type: lists containing elements 'show', 'selected'.
Those elements have the following types:
  - `show` (Bool; optional)
  - `selected` (Bool; optional)
- `useIcon` (Bool; optional)
"""
function ''_getgeometry(; kwargs...)
        available_props = Symbol[:id, :buttonLabel, :defaultKey, :fullWidth, :geometryFilter, :meshOptions, :optionsConfig, :useIcon]
        wild_props = Symbol[]
        return Component("''_getgeometry", "GetGeometry", "pollination_dash_io", available_props, wild_props; kwargs...)
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_studyprogress

"""
    ''_studyprogress(;kwargs...)

A StudyProgress component.
Keep track of a study and get its results
If you click on a file card you get data as base64 string

State
- report (dictionary): Study progress information
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
- `accessToken` (String; optional): JWT token
- `apiKey` (String; optional): API key from Pollination Cloud
- `basePath` (String; optional): Base path of the API.
- `color` (String; optional): Progress bar color
- `isLocal` (Bool; optional): Start as local simulation
- `projectName` (String; optional): Name of the project
- `projectOwner` (String; optional): Owner of the project
- `refreshInterval` (Real; optional): Refresh interval in milliseconds
- `run` (required): Run or Local run to fetch. run has the following type: lists containing elements 'author', 'generation', 'id', 'meta', 'owner', 'recipe', 'status'.
Those elements have the following types:
  - `author` (optional): author
@,type,{AccountPublic}
@,memberof,Run. author has the following type: lists containing elements 'account_type', 'description', 'display_name', 'id', 'name', 'picture_url'.
Those elements have the following types:
  - `account_type` (String; required)
  - `description` (String; optional)
  - `display_name` (String; optional)
  - `id` (String; required)
  - `name` (String; required)
  - `picture_url` (String; optional): https://robohash.org/ladybugbot
@,type,{string}
@,memberof,AccountPublic
  - `generation` (Real; optional): The generation of this run
@,type,{number}
@,memberof,Run
  - `id` (String; required): The unique ID for this run
@,type,{string}
@,memberof,Run
  - `meta` (optional): Extra metadata about the run
@,type,{RunMeta}
@,memberof,Run. meta has the following type: lists containing elements 'progress', 'resources_duration'.
Those elements have the following types:
  - `progress` (optional): progress of the run
@,type,{RunProgress}
@,memberof,RunMeta. progress has the following type: lists containing elements 'completed', 'running', 'total'.
Those elements have the following types:
  - `completed` (Real; optional)
  - `running` (Real; optional)
  - `total` (Real; optional)
  - `resources_duration` (optional): resource usage
@,type,{ResourcesDuration}
@,memberof,RunMeta. resources_duration has the following type: lists containing elements 'cpu', 'memory'.
Those elements have the following types:
  - `cpu` (Real; optional)
  - `memory` (Real; optional)
  - `owner` (optional): owner
@,type,{AccountPublic}
@,memberof,Run. owner has the following type: lists containing elements 'account_type', 'description', 'display_name', 'id', 'name', 'picture_url'.
Those elements have the following types:
  - `account_type` (String; required)
  - `description` (String; optional)
  - `display_name` (String; optional)
  - `id` (String; required)
  - `name` (String; required)
  - `picture_url` (String; optional): https://robohash.org/ladybugbot
@,type,{string}
@,memberof,AccountPublic
  - `recipe` (optional): The recipe used to generate this
@,type,{RecipeInterface}
@,memberof,Run. recipe has the following type: lists containing elements 'annotations', 'api_version', 'inputs', 'metadata', 'outputs', 'source', 'type'.
Those elements have the following types:
  - `annotations` (Dict with Strings as keys and values of type String; optional): An optional dictionary to add annotations to inputs. These annotations will be used by the client side libraries.
@,type,{{ [key: string]: string; }}
@,memberof,RecipeInterface
  - `api_version` (String; optional)
  - `inputs` (Array of Bool | Real | String | Dict | Arrays; optional): A list of recipe inputs.
@,type,{Array<DAGGenericInput | DAGStringInput | DAGIntegerInput | DAGNumberInput | DAGBooleanInput | DAGFolderInput | DAGFileInput | DAGPathInput | DAGArrayInput | DAGJSONObjectInput>}
@,memberof,RecipeInterface
  - `metadata` (required): Recipe metadata information.
@,type,{MetaData}
@,memberof,RecipeInterface. metadata has the following type: lists containing elements 'annotations', 'app_version', 'deprecated', 'description', 'home', 'icon', 'keywords', 'license', 'maintainers', 'name', 'sources', 'tag', 'type'.
Those elements have the following types:
  - `annotations` (Dict with Strings as keys and values of type String; optional): An optional dictionary to add annotations to inputs. These annotations will be used by the client side libraries.
@,type,{{ [key: string]: string; }}
@,memberof,MetaData
  - `app_version` (String; optional): The version of the application code underlying the manifest
@,type,{string}
@,memberof,MetaData
  - `deprecated` (Bool; optional): Whether this package is deprecated
@,type,{boolean}
@,memberof,MetaData
  - `description` (String; optional): A description of what this package does
@,type,{string}
@,memberof,MetaData
  - `home` (String; optional): The URL of this package\'s home page
@,type,{string}
@,memberof,MetaData
  - `icon` (String; optional): A URL to an SVG or PNG image to be used as an icon
@,type,{string}
@,memberof,MetaData
  - `keywords` (Array of Strings; optional): A list of keywords to search the package by
@,type,{Array<string>}
@,memberof,MetaData
  - `license` (optional): The license information.
@,type,{License}
@,memberof,MetaData. license has the following type: lists containing elements 'annotations', 'name', 'type', 'url'.
Those elements have the following types:
  - `annotations` (Dict with Strings as keys and values of type String; optional): An optional dictionary to add annotations to inputs. These annotations will be used by the client side libraries.
@,type,{{ [key: string]: string; }}
@,memberof,License
  - `name` (String; required): The license name used for the package.
@,type,{string}
@,memberof,License
  - `type` (String; optional)
  - `url` (String; optional): A URL to the license used for the package.
@,type,{string}
@,memberof,License
  - `maintainers` (optional): A list of maintainers for the package
@,type,{Array<Maintainer>}
@,memberof,MetaData. maintainers has the following type: Array of lists containing elements 'annotations', 'email', 'name', 'type'.
Those elements have the following types:
  - `annotations` (Dict with Strings as keys and values of type String; optional): An optional dictionary to add annotations to inputs. These annotations will be used by the client side libraries.
@,type,{{ [key: string]: string; }}
@,memberof,Maintainer
  - `email` (String; optional): The email address of the author/maintainer person or organization.
@,type,{string}
@,memberof,Maintainer
  - `name` (String; required): The name of the author/maintainer person or organization.
@,type,{string}
@,memberof,Maintainer
  - `type` (String; optional)s
  - `name` (String; required): Package name. Make it descriptive and helpful ;)
@,type,{string}
@,memberof,MetaData
  - `sources` (Array of Strings; optional): A list of URLs to source code for this project
@,type,{Array<string>}
@,memberof,MetaData
  - `tag` (String; required): The tag of the package
@,type,{string}
@,memberof,MetaData
  - `type` (String; optional)
  - `outputs` (Array of Bool | Real | String | Dict | Arrays; optional): A list of recipe outputs.
@,type,{Array<DAGGenericOutput | DAGStringOutput | DAGIntegerOutput | DAGNumberOutput | DAGBooleanOutput | DAGFolderOutput | DAGFileOutput | DAGPathOutput | DAGArrayOutput | DAGJSONObjectOutput>}
@,memberof,RecipeInterface
  - `source` (String; optional): A URL to the source this recipe from a registry.
@,type,{string}
@,memberof,RecipeInterface
  - `type` (String; optional)
  - `status` (optional): The status of the run
@,type,{RunStatus}
@,memberof,Run. status has the following type: lists containing elements 'annotations', 'api_version', 'entrypoint', 'finished_at', 'id', 'inputs', 'job_id', 'message', 'outputs', 'source', 'started_at', 'status', 'steps', 'type'.
Those elements have the following types:
  - `annotations` (Dict with Strings as keys and values of type String; optional): An optional dictionary to add annotations to inputs. These annotations will be used by the client side libraries.
@,type,{{ [key: string]: string; }}
@,memberof,RunStatus
  - `api_version` (String; optional)
  - `entrypoint` (String; optional): The ID of the first step in the run.
@,type,{string}
@,memberof,RunStatus
  - `finished_at` (String; optional): The time at which the task was completed
@,type,{string}
@,memberof,RunStatus
  - `id` (String; required): The ID of the individual run.
@,type,{string}
@,memberof,RunStatus
  - `inputs` (Array of Bool | Real | String | Dict | Arrays; required): The inputs used for this run.
@,type,{Array<StepStringInput | StepIntegerInput | StepNumberInput | StepBooleanInput | StepFolderInput | StepFileInput | StepPathInput | StepArrayInput | StepJSONObjectInput>}
@,memberof,RunStatus
  - `job_id` (String; required): The ID of the job that generated this run.
@,type,{string}
@,memberof,RunStatus
  - `message` (String; optional): Any message produced by the task. Usually error/debugging hints.
@,type,{string}
@,memberof,RunStatus
  - `outputs` (Array of Bool | Real | String | Dict | Arrays; required): The outputs produced by this run.
@,type,{Array<StepStringOutput | StepIntegerOutput | StepNumberOutput | StepBooleanOutput | StepFolderOutput | StepFileOutput | StepPathOutput | StepArrayOutput | StepJSONObjectOutput>}
@,memberof,RunStatus
  - `source` (String; optional): Source url for the status object. It can be a recipe or a function.
@,type,{string}
@,memberof,RunStatus
  - `started_at` (String; required): The time at which the task was started
@,type,{string}
@,memberof,RunStatus
  - `status` (a value equal to: 'Created', 'Scheduled', 'Running', 'Post-Processing', 'Failed', 'Cancelled', 'Succeeded', 'Unknown'; optional): The status of this run.
@,type,{RunStatusEnum}
@,memberof,RunStatus
  - `steps` (optional): . steps has the following type: Dict with Strings as keys and values of type lists containing elements 'annotations', 'boundary_id', 'children_ids', 'command', 'finished_at', 'id', 'inputs', 'message', 'name', 'outbound_steps', 'outputs', 'source', 'started_at', 'status', 'status_type', 'template_ref', 'type'.
Those elements have the following types:
  - `annotations` (Dict with Strings as keys and values of type String; optional): An optional dictionary to add annotations to inputs. These annotations will be used by the client side libraries.
@,type,{{ [key: string]: string; }}
@,memberof,StepStatus
  - `boundary_id` (String; optional): This indicates the step ID of the associated template root             step in which this step belongs to. A DAG step will have the id of the             parent DAG for example.
@,type,{string}
@,memberof,StepStatus
  - `children_ids` (Array of Strings; required): A list of child step IDs
@,type,{Array<string>}
@,memberof,StepStatus
  - `command` (String; optional): The command used to run this step. Only applies to Function steps.
@,type,{string}
@,memberof,StepStatus
  - `finished_at` (String; optional): The time at which the task was completed
@,type,{string}
@,memberof,StepStatus
  - `id` (String; required): The step unique ID
@,type,{string}
@,memberof,StepStatus
  - `inputs` (Array of Bool | Real | String | Dict | Arrays; required): The inputs used by this step.
@,type,{Array<StepStringInput | StepIntegerInput | StepNumberInput | StepBooleanInput | StepFolderInput | StepFileInput | StepPathInput | StepArrayInput | StepJSONObjectInput>}
@,memberof,StepStatus
  - `message` (String; optional): Any message produced by the task. Usually error/debugging hints.
@,type,{string}
@,memberof,StepStatus
  - `name` (String; required): A human readable name for the step. Usually defined by the DAG task name but can be extended if the step is part of a loop for example. This name is unique within the boundary of the DAG/Job that generated it.
@,type,{string}
@,memberof,StepStatus
  - `outbound_steps` (Array of Strings; required): A list of the last step to ran in the context of this step. In the case of a DAG or a job this will be the last step that has been executed. It will remain empty for functions.
@,type,{Array<string>}
@,memberof,StepStatus
  - `outputs` (Array of Bool | Real | String | Dict | Arrays; required): The outputs produced by this step.
@,type,{Array<StepStringOutput | StepIntegerOutput | StepNumberOutput | StepBooleanOutput | StepFolderOutput | StepFileOutput | StepPathOutput | StepArrayOutput | StepJSONObjectOutput>}
@,memberof,StepStatus
  - `source` (String; optional): Source url for the status object. It can be a recipe or a function.
@,type,{string}
@,memberof,StepStatus
  - `started_at` (String; required): The time at which the task was started
@,type,{string}
@,memberof,StepStatus
  - `status` (a value equal to: 'Scheduled', 'Running', 'Failed', 'Succeeded', 'Skipped', 'Unknown'; optional): The status of this step.
@,type,{StepStatusEnum}
@,memberof,StepStatus
  - `status_type` (a value equal to: 'Function', 'DAG', 'Loop', 'Container', 'Unknown'; required): The type of step this status is for. Can be \"Function\", \"DAG\" or \"Loop\"
@,type,{StatusType}
@,memberof,StepStatus
  - `template_ref` (String; required): The name of the template that spawned this step
@,type,{string}
@,memberof,StepStatus
  - `type` (String; optional)
  - `type` (String; optional)
- `showOutput` (Bool; optional): Show inputs and outputs
- `showResult` (Bool; optional): Show visualization set of a CardFile directly
- `showStatusLabel` (Bool; optional): Show status label
"""
function ''_studyprogress(; kwargs...)
        available_props = Symbol[:id, :accessToken, :apiKey, :basePath, :color, :isLocal, :projectName, :projectOwner, :refreshInterval, :run, :showOutput, :showResult, :showStatusLabel]
        wild_props = Symbol[]
        return Component("''_studyprogress", "StudyProgress", "pollination_dash_io", available_props, wild_props; kwargs...)
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_selectproject

"""
    ''_selectproject(;kwargs...)

A SelectProject component.
Select a pollination project

State
- project (dictionary): Project information
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
- `accessToken` (String; optional): JWT token
- `apiKey` (String; optional): API key from Pollination Cloud
- `basePath` (String; optional): Base path of the API.
- `defaultProjectId` (String; optional): Default project
- `projectOwner` (String; optional): Owner of the project
"""
function ''_selectproject(; kwargs...)
        available_props = Symbol[:id, :accessToken, :apiKey, :basePath, :defaultProjectId, :projectOwner]
        wild_props = Symbol[]
        return Component("''_selectproject", "SelectProject", "pollination_dash_io", available_props, wild_props; kwargs...)
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_selectaccount

"""
    ''_selectaccount(;kwargs...)

A SelectAccount component.
Select a pollination account

State
- account (dictionary): Account information
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
- `accessToken` (String; optional): JWT token
- `apiKey` (String; optional): API key from Pollination Cloud
- `basePath` (String; optional): Base path of the API.
- `defaultAccountName` (String; optional): Default account name
"""
function ''_selectaccount(; kwargs...)
        available_props = Symbol[:id, :accessToken, :apiKey, :basePath, :defaultAccountName]
        wild_props = Symbol[]
        return Component("''_selectaccount", "SelectAccount", "pollination_dash_io", available_props, wild_props; kwargs...)
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_gethost

"""
    ''_gethost(;kwargs...)

A GetHost component.
Use this component to get the host name

State
- host (string):
   Name of the host
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
"""
function ''_gethost(; kwargs...)
        available_props = Symbol[:id]
        wild_props = Symbol[]
        return Component("''_gethost", "GetHost", "pollination_dash_io", available_props, wild_props; kwargs...)
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_selectcloudartifact

"""
    ''_selectcloudartifact(;kwargs...)

A SelectCloudArtifact component.
Use this component to get user info
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
- `accessToken` (String; optional): JWT token
- `apiKey` (String; optional): API key from Pollination Cloud
- `basePath` (String; optional): Base path of the API.
- `fileNameMatch` (String; optional): File name filter
- `projectName` (String; optional): Name of the project
- `projectOwner` (String; optional): Owner of the project
- `studyId` (String; optional): ID of the job
- `value` (optional): Initial path where the files are. value has the following type: lists containing elements 'key'.
Those elements have the following types:
  - `key` (String; required)
"""
function ''_selectcloudartifact(; kwargs...)
        available_props = Symbol[:id, :accessToken, :apiKey, :basePath, :fileNameMatch, :projectName, :projectOwner, :studyId, :value]
        wild_props = Symbol[]
        return Component("''_selectcloudartifact", "SelectCloudArtifact", "pollination_dash_io", available_props, wild_props; kwargs...)
end

# AUTO GENERATED FILE - DO NOT EDIT

export ''_selectrecipe

"""
    ''_selectrecipe(;kwargs...)

A SelectRecipe component.
Select a recipe filter from a pollination project

State
- recipe (dictionary): Recipe filter information
Keyword arguments:
- `id` (String; optional): Unique ID to identify this component in Dash callbacks.
- `accessToken` (String; optional): JWT token
- `apiKey` (String; optional): API key from Pollination Cloud
- `basePath` (String; optional): Base path of the API.
- `projectName` (String; optional): Name of the project
- `projectOwner` (String; optional): Owner of the project
- `value` (optional): Default recipe filter. value has the following type: lists containing elements 'owner', 'name', 'tag'.
Those elements have the following types:
  - `owner` (String; required)
  - `name` (String; required)
  - `tag` (String; required)
"""
function ''_selectrecipe(; kwargs...)
        available_props = Symbol[:id, :accessToken, :apiKey, :basePath, :projectName, :projectOwner, :value]
        wild_props = Symbol[]
        return Component("''_selectrecipe", "SelectRecipe", "pollination_dash_io", available_props, wild_props; kwargs...)
end

#!/bin/sh

git fetch --prune
echo "Go to folder"
cd pollination_dash_io
echo "Building distribution"
python setup.py sdist bdist_wheel
echo "Pushing new version to PyPi"
twine upload dist/* -u $PYPI_USERNAME -p $PYPI_PASSWORD
